#This minimalistic Python script was specifically written for SBC (single-board computers) such as Raspberry Pi
#as it allows them to save and archive data from the Takano server with minimum resourse requirements
#Most SBC have (or can download) Python easily and any IDE such as IDLE or Thonny can do
#Experienced programmers can take it from there to build their own Takano related software
#Make sure the latest PYTHON 3 is installed

import urllib.request  #needed for sending http requests to iotsprint.com- computer must have internet connection for script to work
import time            #needed for introducing software delays like 'time.sleep(10)'
import datetime        #needed for reading dates & time like 'now = datetime.datetime.now()'
import os              #needed for creating/accessing directories and files

#USER REGIGTRATION KEY below, RG, is an array holding the user registration key(s) for all boards used
#the first array item is for board#1, the second is for board#2..
#the array can hold as many user registration keys as needed, you just add more to it..or remove if you have a single board..
#here we consider we have 2 boards..
#change it to you registration key(s)
RG=["012345678901","abcdefghijkl"]
#the 'NAME' array below holds the board names: first array item is name of board#1, second array item is name of board#2
#change it to you to the name(s) you like..
NAME=["Mountain_house","office"]

def month_return(mmonth): #function to return name of month as string
    if mmonth==1:
       return "January"
    elif mmonth==2:
      return "February"
    elif mmonth==3:
      return "March"
    elif mmonth==4:
      return "April"
    elif mmonth==5:
      return "May"
    elif mmonth==6:
      return "June"
    elif mmonth==7:
      return "July"
    elif mmonth==8:
      return "August"
    elif mmonth==9:
      return "September"
    elif mmonth==10:
      return "October"
    elif mmonth==11:
      return "November"
    elif mmonth==12:
      return "December"

last_day= 31             #any past day  
last_month= 'December'   #any past month  
last_year= 2018          #any past year  
 
while 1:
    try:
        for index, item in enumerate(RG, start=0):
            wp = urllib.request.urlopen("http://iotsprint.com/uk.php?r="+item)
            pw = wp.read() 
            pw= str(pw,'utf-8').strip()
            print(NAME[index] + "->" + pw)  #print it to console                   
            x = pw.replace("=", ",") #replace '=' sign with a comma in order to separate names from values when saving in .csv files..
    
            #check system time, Year, Month, Day of month
            now = datetime.datetime.now()
            current_day= now.day    
            current_month= month_return(now.month)
            current_year= now.year
            
#directories and subdirectories where .csv files are saved
#uppermost directory, current year directory, is located in the same directory where this script resides
#first the current year then current month, then current day directories are nested in each other
#then files are created in the current day directory, each file name is the name of a hardware board (Mountain_house.csv) and (office.csv)
#a new day directory is created next to the previous day directory when a new day starts (after 00:00 midnight)
#same applies when a new month or year kicks in..            
            
            if current_year != last_year and not(os.path.exists(str(current_year))):
                os.mkdir(str(current_year))
                os.mkdir(str(current_year)+"/"+str(current_month))
                os.mkdir(str(current_year)+"/"+str(current_month)+"/"+str(current_day))
            elif current_month != last_month and not(os.path.exists(str(current_year)+"/"+str(current_month))):
                os.mkdir(str(current_year)+"/"+str(current_month))
                os.mkdir(str(current_year)+"/"+str(current_month)+"/"+str(current_day))
            elif current_day != last_day and not(os.path.exists(str(current_year)+"/"+str(current_month)+"/"+str(current_day))):        
                os.mkdir(str(current_year)+"/"+str(current_month)+"/"+str(current_day))
                
            MyFile= str(current_year) + "/" + str(current_month) + "/" + str(current_day) + "/" + NAME[index] + ".csv"
            if not(os.path.isfile(MyFile)): #create file if it does not exist
                f= open(MyFile,"a+")
                f.close
      
            f= open(MyFile,"a+")  #append  data to end of file
            now = datetime.datetime.now()
            f.write(now.strftime("%H:%M:%S") + "," + str(x)+"\n") #write data to .csv file
            f.close      
    
            time.sleep(10) # 10 ->delays for 10 seconds
                           # 600 ->delays for 10 minutes etc...
                           # you can set it to as much as you want, just don't go below 10
                  
            last_year= current_year     
            last_month= current_month
            last_day= current_day
    except: #try..except error handling to avoid script crash in case of wi-fi interruption of file write failure etc... 
            print("Error")        
            
